#!/bin/bash

CMDNAME=`basename $0`

while getopts awb:g:m:j:l:e:e:h OPT
do
  case $OPT in
    "a" ) FLG_A="TRUE" ;;
    "w" ) FLG_W="TRUE" ;;
    "b" ) FLG_B=${OPTARG} ;;
    "e" ) FLG_E=${OPTARG} ;;
    "e" ) FLG_E=${OPTARG} ;;
    "m" ) FLG_M=${OPTARG} ;;
    "j" ) FLG_J=${OPTARG} ;;
    "l" ) FLG_L=${OPTARG} ;;
    "g" ) FLG_G=${OPTARG} ;;
      * ) echo "Usage: $CMDNAME [-a] [-b binpath] [-m 64] [-j n] [-g optimizeflags] [-e exdflags]" 1>&2
          exit 1 ;;
  esac
done

if [ "$FLG_M" = "64" ] ; then
    ARCH="ARCH=-m64";
else
    ARCH="ARCH=-m32";
fi

if [ "$FLG_B" = "" ] ; then
    BINPATH="";
else
    BINPATH="BINPATH=$FLG_B";
fi

if [ "$FLG_J" = "" ] ; then
    PARAMK=""
else
    PARAMK="-j$FLG_J"
fi

if [ "$FLG_L" = "" ] ; then
    LDEXLIBS=""
else
    LDEXLIBS="LDEXLIBS=\"$FLG_L\""
fi

if [ "$FLG_G" = "" ] ; then
    MKOPT="OPT=-O2"
else
    MKOPT="OPT=\"$FLG_G\" STRIP="
fi

if [ "$FLG_E" = "" ] ; then
    EXDFLAGS=""
else
    EXDFLAGS="EXDFLAGS=\"$FLG_E\""
fi

if [ "$FLG_E" = "" ] ; then
    EXDFLAGS=""
else
    EXDFLAGS="EXDFLAGS=\"$FLG_E\""
fi

MAKEARGS="$BINPATH $ARCH $MKOPT $PARAMK $EXDFLAGS $EXDFLAGS $LDEXLIBS"

if [ "$FLG_A" = "TRUE" ] ; then
    pushd win32 ; make clean ; /bin/bash -c "make $MAKEARGS" ; popd ;
fi
if [ "$FLG_A" = "TRUE" -o "$FLG_W" = "TRUE" ] ; then
pushd win32frame ; make clean ; /bin/bash -c "make $MAKEARGS" ; popd ;
pushd util       ; make clean ; /bin/bash -c "make $MAKEARGS" ; popd ;
fi
make clean ; /bin/bash -c "make $MAKEARGS"
