import std.stdio;
import std.string;
import std.conv;
import std.file;

struct charbuf{
  int  n=0 ;
  char ch ;
} ;

void readvar(T)(File infile, out T x){T[1] b; T[] d = infile.rawRead(b) ; x=d[0] ; return;}
bool isasciinum(int ch){if(ch>='0' && ch<='9'){return true;}else{return false;}}
bool isspace(int ch){if(ch==' ' || ch=='\r' || ch=='\n' || ch=='\t' || ch=='\v' || ch=='\f'){return true;}else{return false;}}
bool isnewline(int ch){if(ch=='\r' || ch=='\n'){return true;}else{return false;}}
void skipcomment(File infile){while(1){char ch; readvar(infile,ch); if(isnewline(ch)==true) break ;}}
char getc(File infile, ref charbuf cb){if(cb.n>0){cb.n=0; return cb.ch;}else{char ch;readvar(infile,ch);return ch;}}
void ungetc(char ch, out charbuf cb){cb.n=1; cb.ch=ch;}

class FilePNM
{
  File   infile ;
  int    width ;
  int    height ;
  int    bpp ;
  int    depth ;
  int    dppb ;
  int    curline ;

  enum FormatType{
    None,
    P1,   // Ascii PBM
    P2,   // Ascii PGM
    P3,   // Ascii PPM
    P4,   // Raw   PBM
    P5,   // Raw   PGM
    P6    // Raw   PPM
  } ;
  FormatType fmttype ;

  enum STATE{
    SKIP1STSPACE,
    RDCOM,
    WAITWIDTH,
    RDWIDTH,
    WAITHEIGHT,
    RDHEIGHT,
    WAITDEPTH,
    RDDEPTH
  }


  this(){
  }

  ~this(){
  }

  int getWidth(){
    return(width) ;
  }

  int getHeight(){
    return(height) ;
  }

  int getBPP(){
    return(bpp) ;
  }

  int open(string fname, string mode="r"){
    infile = File(fname) ;
    int w,h,b,d ;
    if( mode == "r" ){
      if( readinfo(&w,&h,&b,&d)!=0 ){
        return(-1) ;
      }
      width =w ;
      height=h ;
      bpp   =b ;
      depth =d ;
      dppb  = (d/256)==0 ? 1 : 2 ;
      curline=0 ;
    }
    return(0) ;
  }

  int readinfo(int *w, int *h, int *b, int *d){
    *w=0 ;
    *h=0 ;
    *b=0 ;
    *d=0 ;

    char[] magic = new char[2] ;
    infile.readvar(magic[0]) ;
    infile.readvar(magic[1]) ;
    if( magic[0]=='P' ){
      if(      magic[1]=='1' ) fmttype=FormatType.P1 ;
      else if( magic[1]=='2' ) fmttype=FormatType.P2 ;
      else if( magic[1]=='3' ) fmttype=FormatType.P3 ;
      else if( magic[1]=='4' ) fmttype=FormatType.P4 ;
      else if( magic[1]=='5' ) fmttype=FormatType.P5 ;
      else if( magic[1]=='6' ) fmttype=FormatType.P6 ;
      else                     fmttype=FormatType.None ;
    }
    if( fmttype==FormatType.None ) return(-1) ;

    STATE state=STATE.WAITWIDTH ;
    char[] wbuf, hbuf, dbuf ;
    charbuf cb ;
    wbuf.length=0 ;
    hbuf.length=0 ;
    dbuf.length=0 ;
    char ch ;
    bool previsnewline=false ;
    while(1){
      ch=getc(infile,cb) ;
      if( state==STATE.WAITWIDTH ){
        if( ch=='#' && previsnewline==true ){
          skipcomment(infile) ;
          continue ;
        }
        if( isasciinum(ch)==true ){
          ungetc(ch,cb) ;
          state=STATE.RDWIDTH ;
          continue ;
        }
        previsnewline=isnewline(ch) ;
      }else if( state==STATE.RDWIDTH ){
        if( isasciinum(ch)==true ){
          wbuf.length=wbuf.length+1 ;
          wbuf[$-1]=ch ;
          continue ;
        }
        if( isspace(ch)==true ){
          state=STATE.WAITHEIGHT ;
          ungetc(ch,cb) ;
        }

      }else if( state==STATE.WAITHEIGHT ){
        if( ch=='#' && previsnewline==true ){
          skipcomment(infile) ;
          continue ;
        }
        if( isasciinum(ch)==true ){
          ungetc(ch,cb) ;
          state=STATE.RDHEIGHT ;
          continue ;
        }
        previsnewline=isnewline(ch) ;
      }else if( state==STATE.RDHEIGHT ){
        if( isasciinum(ch)==true ){
          hbuf.length=hbuf.length+1 ;
          hbuf[$-1]=ch ;
          continue ;
        }
        if( isspace(ch)==true ){
          if( fmttype==FormatType.P1 || fmttype==FormatType.P4 ){
            dbuf.length=1;
            dbuf[0]='0' ;
            break ;
          }else{
            state=STATE.WAITDEPTH ;
            ungetc(ch,cb) ;
          }
        }

      }else if( state==STATE.WAITDEPTH ){
        if( ch=='#' && previsnewline==true ){
          skipcomment(infile) ;
          continue ;
        }
        if( isasciinum(ch)==true ){
          ungetc(ch,cb) ;
          state=STATE.RDDEPTH ;
          continue ;
        }
      }else if( state==STATE.RDDEPTH ){
        if( isasciinum(ch)==true ){
          dbuf.length=dbuf.length+1 ;
          dbuf[$-1]=ch ;
          continue ;
        }
        if( isspace(ch)==true ) break ;
      }
    }
    *w=std.conv.to!(int)(wbuf.idup) ;
    *h=std.conv.to!(int)(hbuf.idup) ;
    *b=24 ;
    *d=std.conv.to!(int)(dbuf.idup) ;
    if( *d>65535 ) return(-1) ;
    return(0) ;
  }

  int getint(){
    charbuf cb ;
    char[]  dbuf ;
    size_t  ptr ;
    enum RDSTATE{
      SKIPSPACE,
      RDDATA
    };
    RDSTATE state=RDSTATE.SKIPSPACE ;

    dbuf.length=5 ;
    ptr=0 ;
    while(1){
      char ch=getc(infile,cb) ;
      if( isspace(ch) ) {
        if( state==RDSTATE.SKIPSPACE ) continue ;
        else break ;
      }
      state=RDSTATE.RDDATA ;
      if( ptr<dbuf.length ) dbuf[ptr++]=ch ;
    }
    dbuf.length=ptr ;
    return( std.conv.to!(int)(dbuf.idup) ) ;
  }


  uint[] readline(int lnum=1){
    uint[]  img ;
    img.length=width*lnum ;

    switch(fmttype){
    case FormatType.P1 :
      for( int y=0 ; y<lnum && curline<height ; y++, curline++ ){
        for( int x=0 ; x<width ; x++ ){
          int  v ;
          char ch ;
          while(1){
            charbuf cb ;
            ch=getc(infile,cb) ;
            if( isspace(ch) ) continue ;
            break ;
          }
          v = ch=='0' ? 255 : 0 ;
          img[width*y+x]=(0xff000000 | v<<16 | v<<8 | v) ;
        }
      }
      break ;

    case FormatType.P2 :
      for( int y=0 ; y<lnum && curline<height ; y++, curline++ ){
        for( int x=0 ; x<width ; x++ ){
          int v=(getint()*255 / depth) & 0xff ;
          img[width*y+x]=(0xff000000 | v<<16 | v<<8 | v) ;
        }
      }
      break ;

    case FormatType.P3 :
      for( int y=0 ; y<lnum && curline<height ; y++, curline++ ){
        for( int x=0 ; x<width ; x++ ){
          int r = (getint()*255 / depth) & 0xff ;
          int g = (getint()*255 / depth) & 0xff ;
          int b = (getint()*255 / depth) & 0xff ;
          img[width*y+x]=(0xff000000 | b<<16 | g<<8 | r) ;
        }
      }
      break ;

    case FormatType.P4 :
      int   bwidth= width/8 + (width%8!=0) ;
      ubyte[] rbuf= new ubyte[bwidth] ;

      for( int y=0 ; y<lnum && curline<height ; y++, curline++ ){
        rbuf = infile.rawRead(rbuf) ;
        for( int x=0 ; x<width ; x++ ){
          int v=(rbuf[x/8] & (0x80>>(x%8)))==0 ? 255 : 0 ;
          img[width*y+x]=(0xff000000 | v<<16 | v<<8 | v) ;
        }
      }
      break ;

    case FormatType.P5 :
      ubyte[] rbuf = new ubyte[width*dppb] ;
      for( int y=0 ; y<lnum && curline<height ; y++, curline++ ){
        rbuf = infile.rawRead(rbuf) ;
        for( int x=0 ; x<width ; x++ ){
          if( dppb==1 ){
            int v ;
            v=(rbuf[x]*255 / depth) & 0xff ;
            img[width*y+x]=(0xff000000 | v<<16 | v<<8 | v) ;
          }else{
            int v ;
            v=((rbuf[x*2+0]*256+rbuf[x*2+1]) * 255 / depth) & 0xff ;
            img[width*y+x]=(0xff000000 | v<<16 | v<<8 | v) ;
          }
        }
      }
      break ;

    case FormatType.P6 :
      ubyte[] rbuf = new ubyte[3*width*dppb] ;
      for( int y=0 ; y<lnum && curline<height ; y++, curline++ ){
        rbuf = infile.rawRead(rbuf) ;
        for( int x=0 ; x<width ; x++ ){
          if( dppb==1 ){
            int r= (rbuf[x*3+0] * 255 / depth) & 0xff ;
            int g= (rbuf[x*3+1] * 255 / depth) & 0xff ;
            int b= (rbuf[x*3+2] * 255 / depth) & 0xff ;
            img[width*y+x]=(0xff000000 | b<<16 | g<<8 | r) ;
          }else{
            int r= ((rbuf[x*6+0]*256+rbuf[x*6+1]) * 255 / depth) & 0xff ;
            int g= ((rbuf[x*6+2]*256+rbuf[x*6+3]) * 255 / depth) & 0xff ;
            int b= ((rbuf[x*6+4]*256+rbuf[x*6+5]) * 255 / depth) & 0xff ;
            img[width*y+x]=(0xff000000 | b<<16 | g<<8 | r) ;
          }
        }
      }
      break ;
    default :
      break ;
    }
    return(img) ;
  }

  int close(){
    infile.detach() ;
    return(0) ;
  }
}

version (PNM_DEBUG){
int main(string[] args)
{
  FilePNM pnm = new FilePNM() ;
  pnm.open(args[1]) ;
  writef("w=%d h=%d b=%d\n", pnm.width, pnm.height, pnm.bpp) ;
  int w = pnm.getWidth() ;
  int h = pnm.getHeight() ;

  File   outfile ;
  char[] cimg ;
  outfile = File("outputtest.ppm","wb") ;
  outfile.writef("P6\n%d %d\n255\n",w,h) ;

  cimg.length=w*h*3 ;
  uint[] l ;
  l = pnm.readline(h) ;
  for( int x=0 ; x<w*h ; x++ ){
    cimg[x*3+2] = (l[x] & 0x00ff0000)>>16 ;
    cimg[x*3+1] = (l[x] & 0x0000ff00)>>8  ;
    cimg[x*3+0] = (l[x] & 0x000000ff)     ;
  }
  outfile.rawWrite(cimg) ;

  outfile.detach() ;

  return(0) ;
}
}
